function nmodel = appearance_ml(images, model)

[numjoints x] = size(model.THETA.u);

nmodel = model;

for j = 1:numjoints
    
    s = model.THETA.u(j, 1);
    sig = model.THETA.u(j, 2);
    alpha = model.THETA.u(j, 3);
    m = model.THETA.u(j, 4:35);

    p = 0;
    
    ns = [ 0 0 ];
    nmiddle = [ 0 0 ];
    nsig = 0;
    nalpha = 0;
    nm = zeros(1, 32);
    
    for i=1:length(images)
        img = images(i);

        locs = img.locations; 
        descrs = img.descriptors; 
        dists = img.dists;
        
        [ndescrs x] = size(locs);
        
        for d = 1:ndescrs
            p_this = dists(j);
            p = p + p_this;
            
            nm = nm + p_this*descrs(d, :);
            nsig = nsig + p_this*descrs(d, :).^2;
            
            nmiddle = nmiddle + p_this*locs(d, :);
            ns = ns + p_this*locs(d, :).^2;
            
            nalpha = nalpha + p_this;
        end
    end

    nm = nm/p;
    nsig = nsig/p;
    nmiddle = nmiddle/p;
    ns = ns/p;
    
    nsig = sqrt(sum(nsig - nm.^2));
    ns = sqrt(sum(ns - nmiddle.^2));
    
    nmodel.THETA.u(j, 1) = ns;
    nmodel.THETA.u(j, 2) = nsig;
    nmodel.THETA.u(j, 3) = nalpha;
    nmodel.THETA.u(j, 4:35) = nm;

end

sumalphas = sum(nmodel.THETA.u(:,3));
nmodel.THETA.u(:, 3) = nmodel.THETA.u(:, 3) / (sumalphas + nmodel.THETA.beta);

    


