function B = best_loc(rkd, kv, j, i, THETA, Bs)
% return B_j(l_i) as a table
% Bs(m, n) = Bmn, with the entries that we need 
% i.e. Bcj for all c children of j (neighbors != i)

B.best = -ones(480, 640);
B.best_x = zeros(480, 640);
B.best_y = zeros(480, 640);
B.sample = 32;
sample = B.sample;

sx = THETA.c.sx(i, j);
sy = THETA.c.sy(i, j);
std = THETA.c.std(i, j);

E=THETA.E;  % adjacency matrix
adj = E(j, :);

for xi = 1:sample:640
    xi;
    for yi = 1:sample:480
        % i.e. (xi,yi) is location of i'th joint      
        bestsofar = inf;
        bestxsofar = 1; bestysofar = 1;
        
        lstd = log(1/(std*sqrt(2*pi)));
        std2 = 1/(2*std^2);
        
        for xj = 1:sample:640
            for yj = 1:sample:480
                
                % considering (xj, yj) as the location for
                % the j'th joint

                p = probdata(rkd, kv, THETA, yj, xj, j);
      %          
                t = [xj yj] - [xi yi] - [sx sy];               
                t = t.*t;
                
                p = p + lstd - sum(t)*std2;
      %          [xj yj xi yi sx sy std p]
                if(p == 0)
                    continue;
                end
                
                bestness = -p;

                for c=1:length(adj)
                    if(adj(c) == 1 && c ~= i)
                        %[c i j]
                        Bc = Bs(c, j);
                        best = Bc.best(yj, xj);
                        bestness = best + bestness;
                    end
                end

                if(bestness < bestsofar)
                    bestsofar = bestness; bestxsofar = xj; bestysofar = yj;
                end
            end
        end    
        
        B.best(yi, xi) = bestsofar;
        B.best_x(yi, xi) = bestxsofar;
        B.best_y(yi, xi) = bestysofar;
        
    end
end
