function images = estimate(images, model)

[numjoints x] = size(model.THETA.u);

for i=1:length(images)
    img = images(i);

    locs = img.locations;
    descrs = img.descriptors;
    
    [ndescrs x] = size(locs);
    
    for d = 1:ndescrs
        loc_x = locs(d, 2);
        loc_y = locs(d, 1);
        desc = descrs(d, :);

        dist = zeros(numjoints, 1);
        tally = 0;
        for j = 1:numjoints

            s = model.THETA.u(j, 1);
            sig = model.THETA.u(j, 2);
            alpha = model.THETA.u(j, 3);
            m = model.THETA.u(j, 4:35);

            mx = img.L(j, 2);
            my = img.L(j, 1);
            
            dist(j) = 1/(s*sqrt(2))*exp(-((mx - loc_x)^2 + (my - loc_y)^2)/(2*s^2));
           
            t = 1/(sig*sqrt(2)) * exp(-sum( (desc-m).^2 )/(2*sig^2));
            dist(j) = dist(j) * t;           
            tally = tally + dist(j);
        end        
        
        if(tally ~= 0)
            dist = dist/tally;
        else
            dist = ones(numjoints,1)/numjoints;
        end
        
        images(i).dists(d, 1:numjoints) = dist;  % alphas
        images(i).dists(d, numjoints+1) = 0; % beta
    end
end
