function L = map_loc(rkd, kv, THETA) 

[numjoints x] = size(THETA.u);

E = THETA.E;

nextjoint = pick_leaf(E)
[E parent] = drop(E, nextjoint);
parent
Bs(nextjoint, parent) = best_loc(rkd, kv, nextjoint, parent, THETA, 0);
%subplot(numjoints-1, 1, 1); imagesc(exp(-Bs(nextjoint, parent).best(1:32:480, 1:32:640)));


for k=2:(numjoints-1)
   nextjoint = pick_leaf(E)
   [E parent] = drop(E, nextjoint);
   parent
   
   Bs(nextjoint, parent) = best_loc(rkd, kv, nextjoint, parent, THETA, Bs);
%   subplot(numjoints-1, 1, k);

%   imagesc(exp(-Bs(nextjoint, parent).best(1:32:480, 1:32:640)));
%   drawnow();
end

E = THETA.E;

best = inf; bestx = 0; besty=0;

for yi = 1:32:480
    for xi = 1:32:640
        p = probdata(rkd, kv, THETA, yi, xi, parent);
        
        bestness = -p + Bs(nextjoint, parent).best(yi, xi);
        
        if(bestness < best) 
           best =  bestness;
           bestx = xi;
           besty = yi;
        end
    end
end

resolvedx = zeros(numjoints,1);
resolvedy = zeros(numjoints,1);
resolved = zeros(numjoints,1);
resolved(parent) = 1;
resolvedx(parent) = bestx;
resolvedy(parent) = besty;

for i=2:numjoints
    % find a child of a resolved node
    for j = 1:numjoints
        if(resolved(j) == 0)
            neighbors = E(j, :);
            found = false;
            for k = 1:length(neighbors)
                if(neighbors(k) == 1 && resolved(k) == 1)
                    found = true;
                    break;
                end
            end

            if(found)
                B = Bs(j, k);
                resolved(j) = 1;
                resolvedx(j) = B.best_x(resolvedx(k), resolvedy(k))
                resolvedy(j) = B.best_y(resolvedx(k), resolvedy(k))
            end
        end
    end

end

L(:, 1) = resolvedy;
L(:, 2) = resolvedx;


function j = pick_leaf(E)
[n x] = size(E);
j = 0;
for i = 1:n
   if(sum(E(i, :)) == 1) 
       j = i;
       break;
   end
end

function [E2 parent] = drop(E, i) 
E2 = E;
i;
c = E2(i, :);
E2(i, :) = 0*c;
E2(:, i) = 0*c';
parent = c * (1:length(c))';
E2;
L = 0;
